#pragma once

#include <string>
#include <filesystem>

#include "loggger.h"
#include "collection.h"

class Component {
public:
    enum State {
        initial,
        reading,
        building,
        ready
    };

    enum Type {
        unknown,
        file,
        directory,
        mason
    };

    Component(Logger* logger, Collection* collection);
    virtual ~Component();

    Type getType() const;
    Type getState() const;

    virtual void read(const std::filesystem::path& path) = 0;
    virtual void build(const std::filesystem::path& destination, const std::string& target) = 0;

protected:
    State state;
    Type type;
    Logger* logger;
    Collection* collection;
    std::filesystem::path location;
};
